import  {mapData} from '/mapData.js';
console.log(mapData[1].latitude)
//get geojson data
// var countryData;
// $.getJSON('/public/json/medium.geo.json', function(data) {
//     countryData = data;
// });

var mymap = L.map(mapViewId);
mymap.fitWorld().zoomIn();
//var mymap = L.map('mapViewId').setView([116.5, 40], 4);
//  https://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}{r}.png  
//  https://{s}.basemaps.cartocdn.com/light_nolabels/{z}/{x}/{y}{r}.png
//  http://{s}.tiles.wmflabs.org/bw-mapnik/{z}/{x}/{y}.png
//  https://server.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Light_Gray_Base/MapServer/tile/{z}/{y}/{x}
//  https://{s}.basemaps.cartocdn.com/rastertiles/voyager/{z}/{x}/{y}{r}.png
L.tileLayer('https://{s}.basemaps.cartocdn.com/rastertiles/voyager/{z}/{x}/{y}{r}.png', {
    maxZoom: 18,
    //attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
}).addTo(mymap);


var divIcon = L.divIcon({ 
  html: "textToDisplay"
})

//loop map data
var latlong = [];
for (var i = 0 ; i <= mapData.length ; i++) {
  let lat = mapData[i].latitude;
  let long = mapData[i].longitude;
  if (!isNaN(lat) && !isNaN(long)) {
    var marker = new L.marker([lat, long], {icon: divIcon, opacity: 0 }); //opacity may be set to zero
    marker.bindTooltip(mapData[i].name, {permanent: false, className: "my-label", offset: [0, 0] });
    //marker.bindTooltip(mapData[i].Percent_site);
    marker.bindPopup("Epidemiology prevalence: "+mapData[i].EPIDEMIOLOGY+"<br>"+
                     "Global score: "+mapData[i].GLOB_SCORE);
    marker.addTo(mymap);
    latlong.push([lat, long]);
  };
}

// control that shows state info on hover
var info = L.control();
var geojson;

info.onAdd = function(map) {
    this._div = L.DomUtil.create("div", "info");
    this.update();
    return this._div;
};

info.update = function(props) {
    this._div.innerHTML =
        "<h5>Geographical Distribution</h5>" +
        (props ? 
            "<b>" + props.info.COUNTRY_NAME + "</b> <br/>" +
            //(props.info.LAUNCH? "Launch (High / medium / low probability): " + props.info.LAUNCH + "<br />":"") +
            //(props.info.PTA_OLE? "PTA / OLE (Required yes/no): " + props.info.PTA_OLE + "<br />":"") +
            //(props.info.EPIDEMIOLOGY? "# prevalent cases in targeted pathology: " + props.info.EPIDEMIOLOGY + "<br />":"") +
            //(props.info.SETUP_TIMELINE? "# days between CTA submission and 1st SIV in reference studies: " + props.info.SETUP_TIMELINE + "<br />":"") +
            //(props.info.PARTNER_SITES? "# partner sites for planned study: " + props.info.PARTNER_SITES + "<br />":"") +
            //(props.info.I_PERFORMANCE_1? "CRR in reference studies (p/s/m): " + props.info.I_PERFORMANCE_1 + "<br />":"")+
            (props.info.I_PERFORMANCE_1? "Actual Score: " + props.info.I_PERFORMANCE_1 + "<br />":"")
            //(props.info.I_PERFORMANCE_2? "% inactive sites in reference studies: " + props.info.I_PERFORMANCE_2 + "<br />":"")+
            //(props.info.I_PERFORMANCE_3? "% pts actual/planned in reference studies: " + props.info.I_PERFORMANCE_3 + "<br />":"")+
            //(props.info.I_COMPETITION? "# sites in internal competing studies: " + props.info.I_COMPETITION + "<br />":"")+
            //(props.info.E_EXPERIENCE? "# completed / closed studies: " + props.info.E_EXPERIENCE + "<br />":"") +
            //(props.info.E_COMPETITION? "# ongoing / planned studies: " + props.info.E_COMPETITION + "<br />":"") +
            //(props.info.INVESTIGATORS_1? "# investigators in Impact: " + props.info.INVESTIGATORS_1 + "<br />":"") +
            //(props.info.INVESTIGATORS_2? "# T1 investigators in Sitetrove +: " + props.info.INVESTIGATORS_2 + "<br />":"") +
            //(props.info.INVESTIGATORS_3 ? "# sites in EHR: " + props.info.INVESTIGATORS_3 + "<br />":"") 
            : "Hover over a country");
};


info.addTo(mymap);



//getColor
function getColor(d) {  
        return  d == 1 ?  "#9BD1E5" :     
                d == 2 ?  "#6DA3C7" :       
                d == 3 ?  "#5386E4" :
                d == 4 ?  "#4C4B63" :           
                          "#D1FAFF";
}



function style(feature) {
    return {
        fillColor: getColor(feature.info.GLOB_SCORE),
        weight: 1,
        opacity: 1,
        color: 'white',
        dashArray: '1',
        fillOpacity: 0.8
    };
}


//L.geoJson(newData, {style: style}).addTo(mymap);


function highlightFeature(e) {
    var layer = e.target;

    layer.setStyle({
        weight: 1,
        color: '#d0d1e6',
        dashArray: '',
        fillOpacity: 0.6
    });

    if (!L.Browser.ie && !L.Browser.opera && !L.Browser.edge) {
        layer.bringToFront();
    }

    //info.update(layer.feature.properties);
    info.update(layer.feature);
}

function resetHighlight(e) {
    geojson.resetStyle(e.target);
    info.update();
}




function zoomToFeature(e) {
    map.fitBounds(e.target.getBounds());
}

function onEachFeature(feature, layer) {
    layer.on({
        mouseover: highlightFeature,
        mouseout: resetHighlight,
        click: zoomToFeature
    });
}


// zero padding
function pad(num, size) {
    var s = num+"";
    while (s.length < size) s = "0" + s;
    return s;
}

geojson = L.geoJson(newData, {
    style: style,
    onEachFeature: onEachFeature
}).addTo(mymap);




//loop map data
// add data
var newData = {"type":"FeatureCollection","features":[]}
for (i=0; i<countryData.features.length; i++) {
        //country_name_i = countryData.features[i].properties.name.toUpperCase()
        country_code_i = countryData.features[i].properties.iso_n3
    for (j =0; j < mapData.length; j++) {
        //country_name_j = mapData[j].COUNTRY_NAME;
        country_code_j = pad(mapData[j].COUNTRY_CODE,3);
        if (country_code_i == country_code_j) {
            t = countryData.features[i]
            t.info = mapData[j]
            newData.features.push(t);
        }

    }
};

geoJson = L.geoJson(newData, {
    style: style,
    onEachFeature: onEachFeature
}).addTo(mymap);


//Legend
var legend = L.control({position: 'bottomleft'});
legend.onAdd = function (mymap) {
    var div = L.DomUtil.create('div', 'info legend');
        labels = ['<strong>Global Score</strong>'];
        grades = [0, 1, 2, 3, 4];

    // loop through our density intervals and generate a label with a colored square for each interval
   for (var i = 0; i < grades.length; i++) {
         div.innerHTML +=
            '<i style="background:' + getColor(grades[i]) + ' "></i> ' +
            grades[i] + "   "+'<br>';
    }
    div.innerHTML = labels[0] + '<br>' +div.innerHTML;
    return div;
};

legend.addTo(mymap);



// var map = L.map('map').setView([37.8, -96], 4);

// 	L.tileLayer('https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=pk.eyJ1IjoibWFwYm94IiwiYSI6ImNpejY4NXVycTA2emYycXBndHRqcmZ3N3gifQ.rJcFIG214AriISLbB6B5aw', {
// 		maxZoom: 18,
// 		attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, ' +
// 			'<a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, ' +
// 			'Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
// 		id: 'mapbox.light'
// 	}).addTo(map);


// 	// control that shows state info on hover
// 	var info = L.control();

// 	info.onAdd = function (map) {
// 		this._div = L.DomUtil.create('div', 'info');
// 		this.update();
// 		return this._div;
// 	};

// 	info.update = function (props) {
// 		this._div.innerHTML = '<h4>US Population Density</h4>' +  (props ?
// 			'<b>' + props.name + '</b><br />' + props.density + ' people / mi<sup>2</sup>'
// 			: 'Hover over a state');
// 	};

// 	info.addTo(map);


// 	// get color depending on population density value
// 	function getColor(d) {
// 		return d > 1000 ? '#800026' :
// 				d > 500  ? '#BD0026' :
// 				d > 200  ? '#E31A1C' :
// 				d > 100  ? '#FC4E2A' :
// 				d > 50   ? '#FD8D3C' :
// 				d > 20   ? '#FEB24C' :
// 				d > 10   ? '#FED976' :
// 							'#FFEDA0';
// 	}

// 	function style(feature) {
// 		return {
// 			weight: 2,
// 			opacity: 1,
// 			color: 'white',
// 			dashArray: '3',
// 			fillOpacity: 0.7,
// 			fillColor: getColor(feature.properties.density)
// 		};
// 	}

// 	function highlightFeature(e) {
// 		var layer = e.target;

// 		layer.setStyle({
// 			weight: 5,
// 			color: '#666',
// 			dashArray: '',
// 			fillOpacity: 0.7
// 		});

// 		if (!L.Browser.ie && !L.Browser.opera && !L.Browser.edge) {
// 			layer.bringToFront();
// 		}

// 		info.update(layer.feature.properties);
// 	}

// 	var geojson;

// 	function resetHighlight(e) {
// 		geojson.resetStyle(e.target);
// 		info.update();
// 	}

// 	function zoomToFeature(e) {
// 		map.fitBounds(e.target.getBounds());
// 	}

// 	function onEachFeature(feature, layer) {
// 		layer.on({
// 			mouseover: highlightFeature,
// 			mouseout: resetHighlight,
// 			click: zoomToFeature
// 		});
// 	}

// 	geojson = L.geoJson(statesData, {
// 		style: style,
// 		onEachFeature: onEachFeature
// 	}).addTo(map);

// 	map.attributionControl.addAttribution('Population data &copy; <a href="http://census.gov/">US Census Bureau</a>');


// 	var legend = L.control({position: 'bottomright'});

// 	legend.onAdd = function (map) {

// 		var div = L.DomUtil.create('div', 'info legend'),
// 			grades = [0, 10, 20, 50, 100, 200, 500, 1000],
// 			labels = [],
// 			from, to;

// 		for (var i = 0; i < grades.length; i++) {
// 			from = grades[i];
// 			to = grades[i + 1];

// 			labels.push(
// 				'<i style="background:' + getColor(from + 1) + '"></i> ' +
// 				from + (to ? '&ndash;' + to : '+'));
// 		}

// 		div.innerHTML = labels.join('<br>');
// 		return div;
// 	};

// 	legend.addTo(map)